﻿#region License Information
/* HeuristicLab
 * Copyright (C) 2002-2012 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
 *
 * This file is part of HeuristicLab.
 *
 * HeuristicLab is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * HeuristicLab is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with HeuristicLab. If not, see <http://www.gnu.org/licenses/>.
 */
#endregion

using HeuristicLab.Common;
using HeuristicLab.Core;
using HeuristicLab.Encodings.ConditionActionEncoding;
using HeuristicLab.Persistence.Default.CompositeSerializers.Storable;

namespace HeuristicLab.Encodings.CombinedIntegerVectorEncoding {
  [Item("CombinedIntegerVectorCoveringCreator", "Description missing")]
  [StorableClass]
  public class CombinedIntegerVectorCoveringCreator : CoveringSolutionCreator, ICombinedIntegerVectorOperator {

    [StorableConstructor]
    protected CombinedIntegerVectorCoveringCreator(bool deserializing) : base(deserializing) { }
    protected CombinedIntegerVectorCoveringCreator(CombinedIntegerVectorCoveringCreator original, Cloner cloner)
      : base(original, cloner) {
    }
    public override IDeepCloneable Clone(Cloner cloner) {
      return new CombinedIntegerVectorCoveringCreator(this, cloner);
    }
    public CombinedIntegerVectorCoveringCreator()
      : base() {
    }

    protected override IClassifier CreateCoveredClassifier(IInput input, IAction action, IRandom random, double changeSymbolProbability) {
      CombinedIntegerVector newCondition = (CombinedIntegerVector)input.Clone();

      CombinedIntegerVector condition = (CombinedIntegerVector)input;
      CombinedIntegerVector newAction = (CombinedIntegerVector)action;

      newCondition = UniformSomePositionManipulator.ManipulateCondition(random, condition, newCondition, changeSymbolProbability);

      return new CombinedIntegerVector(newCondition, newCondition.Bounds, newAction, newAction.Bounds);
    }
  }
}
