﻿#region License Information
/* HeuristicLab
 * Copyright (C) 2002-2012 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
 *
 * This file is part of HeuristicLab.
 *
 * HeuristicLab is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * HeuristicLab is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with HeuristicLab. If not, see <http://www.gnu.org/licenses/>.
 */
#endregion

using System;
using HeuristicLab.Core;

namespace HeuristicLab.Encodings.VariableVector {
  public interface IVariable : IItem {
    string VariableName { get; }
    int VirtualLength { get; }
    Type VariableType { get; }

    IVariable GetEmptyCopy();
    IVariable GetSetCopy();
    void Randomize(IRandom random);
    bool MatchInput(string target);
    bool MatchVariable(IVariable target);

    bool Identical(IVariable target);

    double GetGenerality();
    bool IsGreaterThanOrEquallyGeneral(IVariable target);

    IVariable CrossParentsAtPosition(IVariable parent2, int pos);

    void Manipulate(IRandom random, string stringValue, int pos);

    void Cover(IRandom random, string stringValue, double changeSymbolProbability);
  }
}
